/* 

                        XPac1.c

                     (Sylvain Huet x91)
                 (huet@poly.polytechnique.fr)

*/

#include "xpac1.h"

int	black,white;
char	*nomstat=NULL;
Display	*display;
int	screen;
Window	root,win;
GC	gc,gcfond,gcform;
	
Pixmap	dessin,fond;

struct Fsprite	fs[8];
Pixmap	myform[nbmickey],myfond[nbmickey];
Pixmap	mysimple[nbsimple],myfonte;
int	lastkey;
int	spritemod;
		
void main(int argc,char **argv)
	{

	int	i,j,i_lose;
	char	c;
	KeySym	ks;
	struct timeval	tm;

	Window	hacktime,win_lose;
	XEvent	ev;
	XSetWindowAttributes	xsw;
	XGCValues	xgc;
	int	hacktimex;

	if(argc==3 &&!strcmp(argv[1],"-d")) nomstat=argv[2];

	display=XOpenDisplay(nomstat);
	screen=DefaultScreen(display);
	root=RootWindow(display,screen);
	black=BlackPixel(display,screen);
	white=WhitePixel(display,screen);
	gc=DefaultGC(display,screen);
	
	xgc.function=GXand;
	gcfond=XCreateGC(display,root,GCFunction,&xgc);
	xgc.function=GXor;
	gcform=XCreateGC(display,root,GCFunction,&xgc);

	win=XCreateSimpleWindow(display, root,0,0,616,400,1,white,black);
	XSetStandardProperties(display, win, "FunzyPacman","FunzyPacman",0,
		argv,argc,NULL);
	XSelectInput(display,win,ExposureMask|KeyPressMask);

	hacktimex=0;
	hacktime=XCreateWindow(display,win,hacktimex,0,1,1,0
			,CopyFromParent,InputOutput,CopyFromParent,0,&xsw);
	XMapWindow(display,hacktime);
	XMapWindow(display,win);

	dessin=XCreatePixmap(display,root,616,400,DefaultDepth(display,screen));
	fond=XCreatePixmap(display,root,616,400,DefaultDepth(display,screen));

	XSetForeground(display,gc,black);
	XFillRectangle(display,dessin,gc,0,0,616,400);
	XSetForeground(display,gc,white);

	inifn();
	inisprite();
	inimickey();
	operation=6;
	spritemod=0;
	ct2=0;

	while(1)
	{
	XNextEvent(display,&ev);
	switch(ev.type)	{
	case Expose:
		do	{
			XCopyArea(display,dessin,win,gc
				,ev.xexpose.x,ev.xexpose.y
				,ev.xexpose.width,ev.xexpose.height
				,ev.xexpose.x,ev.xexpose.y);
			}
		while(XCheckTypedEvent(display,Expose,&ev));
		affn();
		if (spritemod)	clssprite();

		pacman();

		if (spritemod)	affsprite();
		if (spritemod==2) spritemod=0;

		XMoveWindow(display,hacktime,(hacktimex=5-hacktimex),0);
		XSendEvent(display,win,False,ExposureMask,&ev);
		tm.tv_sec=0;
		tm.tv_usec=tempo;
		select(getdtablesize(),NULL,NULL,NULL,&tm);
		break;

	case KeyPress:
		if(XLookupString((XKeyEvent*)&ev,&c,1,&ks,NULL)!=0)
			lastkey=c;
		break;
		
	default:
		break;

	}
	}
	}






