/* 

                        XPacman.h

                     (Sylvain Huet x91)
                 (huet@poly.polytechnique.fr)

*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>

#define tempo 10000
#define nbfen 8
#define nbsprite 8
#define nbmickey 26
#define nbsimple 2
#define nbtableau 4

struct Fsprite
	{
	int	type;
	Pixmap	pixform, pixfond;
	int	x,y;
	int	width,height;
	int	dir;
	int	state;
	int	wait;
	};
typedef struct Fsprite *fsprite;

struct Cheatgame
	{
	int	tableau;
	char	score[9];
	int	vies;
	int	eus;
	int	veut;
	int	compte;
	int	tour;
	int	clk;
	int	clkfruit;
	int	xm;
	int	ym;
	int	xp;
	int	yp;
	int	flagp;
	char	highscore[24*10];
	};
typedef struct Cheatgame *cheatgame;

extern int	black,white;
extern char	*nomstat;
extern Display	*display;
extern int	screen;
extern Window	root,win;
extern GC	gc,gcfond,gcform;
	
extern Pixmap	dessin,fond;
extern struct Fsprite	fs[8];
extern Pixmap	myform[nbmickey],myfond[nbmickey];
extern Pixmap	mysimple[nbsimple];
extern Pixmap	myfonte;
extern int	murs[19][12];
extern int	operation,ct2;
extern struct Cheatgame	game;
extern int	lastkey;
extern int	spritemod;


/*	definition des mickeys	*/
void inimickey();

void inipalette();
/*	definition de la structure fenetre utilisee pour le rafraichissement */
struct Fen
	{
	int	g,h,d,b;
	};
typedef struct Fen	*fen;

void clearfenclc(fen f);

void inifn();

void affzone(fen f);

void affscreen();

void affenclc(fen f);

void affn();

/* definition des routines de gestion de sprite	*/

void inisprite();

/* cree un nouveau sprite qui sera affiche immediatement,
retourne le numero du sprite : -1 si complet	*/

int createsprite(Pixmap pixform, Pixmap pixfond, int x, int y
			, int width, int height, int pref);

void deletesprite(int i);

void clssprite();

void affsprite();

/* definition du fond (affichage du labyrinthe et remplissage de murs[][] */
void initfond();

/* routine de gestion du jeu, depend de operation */
void pacman();







