/* 

                        XPacman.c

                     (Sylvain Huet x91)
                 (huet@poly.polytechnique.fr)

*/

#include "xpac1.h"

#define xminsc 120
#define xminvi 480
#define yminsc 392


int	operation;
struct Cheatgame	game;
int	ct2,statefin;
struct Fen	fensc={xminsc,yminsc,xminsc+8*8,yminsc+8};
struct Fen	fenvi={xminvi,yminsc,xminvi+6*8,yminsc+8};

XPoint	trian[3]={188,140,218,200,158,200};
XPoint	letm[10]={338,140,338,200,360,200,360,196,368,200,376,196,376,200
			,398,200,398,140,368,150};
XPoint	trian2[3]={428,140,458,200,398,200};
XPoint	letn[8]={458,140,458,200,480,200,480,196,518,200,518,140
		,496,140,496,144};

void afchn(int x, int y, char *chn)
	{
	while(*chn!=0)
		{
		XCopyArea(display,myfonte,dessin,gc
			,0,8*(*chn++),8,8,x,y);
		x+=8;
		}
	}

void aftitre()
	{
		int	i;

	XSetForeground(display,gc,white);
	XFillArc(display,dessin,gc,98,140,60,45,0,64*360);
	XFillRectangle(display,dessin,gc,98,140,30,60);
	XFillPolygon(display,dessin,gc,trian,3
			,Complex,CoordModeOrigin);
	XFillArc(display,dessin,gc,218,140,60,60,64*45,64*45*6);
	XFillRectangle(display,dessin,gc,288,165,20,10);
	XFillPolygon(display,dessin,gc,letm,10
			,Complex,CoordModeOrigin);
	XFillPolygon(display,dessin,gc,trian2,3
			,Complex,CoordModeOrigin);
	XFillPolygon(display,dessin,gc,letn,8
			,Complex,CoordModeOrigin);
	XSetForeground(display,gc,black);
	XFillArc(display,dessin,gc,116,157,16,12,0,64*360);
	XFillArc(display,dessin,gc,180,179,16,12,0,64*360);
	XFillArc(display,dessin,gc,420,179,16,12,0,64*360);

	XSetForeground(display,gc,white);
	XDrawRectangle(display,dessin,gc,10,10,596,380);

	afchn(244,244,"par Sylvain HUET");
	afchn(72,300
	   ,"Haut : A        Bas : S        Gauche : O        Droite : P");
	afchn(72,320,"Espace pour jouer");
	afchn(72,340,"Escape pour interrompre");
	if (ct2)
		{
		afchn(244,368,"Score : ");
		for (i=0;i<8;i++)
			XCopyArea(display,myfonte,dessin,gc
				,0,8*game.score[i],8,8,308+8*i,368);
		}

	affscreen();
	}

int getdirkey()
	{
		int	k,d;

	k=lastkey;
	if (k==27) return -1;
	d=4*(k=='A')+3*(k=='O')+2*(k=='S')+(k=='P')
		+4*(k=='a')+3*(k=='o')+2*(k=='s')+(k=='p');
	if (d) return d-1;
	return -1000;
	}

void affscore()
	{
		int	i;

	for(i=0;i<8;i++)
		{
		XCopyArea(display,myfonte,dessin,gc
			,0,8*game.score[i],8,8,xminsc+8*i,yminsc);
		XCopyArea(display,myfonte,fond,gc
			,0,8*game.score[i],8,8,xminsc+8*i,yminsc);
		}
	affzone(&fensc);
	}

void affvies()
	{
		int	i;

	for(i=0;i<6;i++)
		if (i<game.vies)
		{
		XCopyArea(display,mysimple[0],dessin,gc
			,0,0,8,8,xminvi+8*i,yminsc);
		XCopyArea(display,mysimple[0],fond,gc
			,0,0,8,8,xminvi+8*i,yminsc);
		}
		else
		{
		XCopyArea(display,mysimple[1],dessin,gc
			,0,0,8,8,xminvi+8*i,yminsc);
		XCopyArea(display,mysimple[1],fond,gc
			,0,0,8,8,xminvi+8*i,yminsc);
		}
	affzone(&fenvi);
	}
	
void addscore(plus)
	char	*plus;
	{
		int	i,cc=0;
		char	*s=game.score;
	for(i=7;i>=0;i--)
		if ((s[i]+=plus[i]+cc-48)>57)
			{
			cc=1;
			s[i]-=10;
			}
			else
			cc=0;
	affscore();
	}

int possible(int x,int y,int k)
	{
	if (murs[x][y]&(1<<k)) return 0;
	return 1;
	}

void depob(int i,int d)
	{
		int	n=-1,x,y,k=fs[i].dir;
	
	x=fs[i].x; y=fs[i].y;
	x+=d*((k==0)-(k==2)); y+=d*((k==1)-(k==3));
	if (fs[i].wait>=0)
		{
		if (x<-23) x+=32*20-d;
		if (x>615) x-=32*20-d;
		if (y<-23) y+=32*13-d;
		if (y>391) y-=32*13-d;
		}
	if (fs[i].state==0)
		{
		n=(((x-8)&31)>>3)+(((y-8)&31)>>3);
		if (n==3) n=1;
		n+=k*3;
		}
	if (fs[i].state==1)
		if ((game.clk)&&((game.clk>200)||(game.clk&16)) ) n=16+k;
			else n=12+k;
	if (fs[i].state==2) n=20+k;
	
	if (fs[i].state!=3)
		{
		fs[i].pixform=myform[n];
		fs[i].pixfond=myfond[n];
		}
	fs[i].x=x;
	fs[i].y=y;
	}

void depp()
	{
		int	k,x,y,xx,yy;
	
	k=getdirkey();
	if (k==-1) statefin=-1;
	if (k>=0) game.veut=k;
	k=game.veut;
	x=fs[0].x; y=fs[0].y;
	if ( ((x&31)==8)&&((y&31)==8) )
		{
		xx=x>>5; yy=y>>5;
		if ((k>=0)&&(possible(xx,yy,k))) fs[0].dir=k;
		if (!possible(xx,yy,fs[0].dir)) fs[0].dir=-1;
		if (murs[xx][yy]&0x30)
			{
			if (murs[xx][yy]&0x20)
				{
				addscore("00002000");

				game.clk=600;
				}
				else
				{
				addscore("00000100");

				if (--game.eus==0) statefin=-3;
				}			
			XSetForeground(display,gc,black);
			XFillRectangle(display,fond,gc,x+8,y+8,8,8);
			XSetForeground(display,gc,white);
			murs[xx][yy]&=0xffcf;
			}
		}
		else
		if (k==((2+fs[0].dir)&3)) fs[0].dir=k;
		
	if (fs[0].dir!=-1) depob(0,2);
	}

void depf()
	{
		int	k,x,y,dx,dy,px,py;
		int	r,i,d[4];

	px=fs[0].x; py=fs[0].y;
	for(k=1;k<5;k++)
	  {
	  r=fs[k].state;
	  if (fs[k].wait) fs[k].wait--;
	  if ((!fs[k].wait)
	  	&&( (r==2)
	  	    ||((r==1)&&(!game.clk)&&((k!=game.compte+1)||(k<game.tour)))
	  	    ||((r==1)&&(game.clk)&&(game.compte&1)) ))
		{
		x=fs[k].x; y=fs[k].y;
		if ( ((x&31)==8)&&((y&31)==8)&&((x!=game.xm)||(y!=game.ym)) )
			{
			if (fs[k].state==1)
				{
				dx=px; dy=py;
				}
				else
				{
				dx=game.xm; dy=game.ym;
				}
			d[0]=dx-x; d[1]=dy-y; d[2]=x-dx; d[3]=y-dy;
			if ((fs[k].state==1)&&(game.clk))
				{
				d[0]=-d[0]; d[1]=-d[1];
				d[2]=-d[2]; d[3]=-d[3];
				}
			if (fs[k].state==1)
				{
				if (k==2)	{
					d[0]<<=3; d[2]<<=3;
					}
				if (k==3)	{
					d[1]<<=3; d[3]<<=3;
					}
				if (k==4)	{
					if (d[0]*d[1]>0)
						{
						r=d[0]; d[0]=d[1]; d[1]=r;
						r=d[2]; d[2]=d[3]; d[3]=r;
						}
						else
						{
						r=d[0]; d[0]=d[3]; d[3]=r;
						r=d[2]; d[2]=d[1]; d[1]=r;
						}
					}
				}
			d[(2+fs[k].dir)&3]=-10000;
			fs[k].dir=-1;
			while(fs[k].dir==-1)
				{
				r=0;
				for(i=1;i<4;i++) if (d[i]>d[r]) r=i;
				if ( (possible(x>>5,y>>5,r))
				   || ( (fs[k].state==2)
				   	&&(x+32*((r==0)-(r==2))==game.xm)
					&&(y+32*((r==1)-(r==3))==game.ym) ) )
					fs[k].dir=r;
					else d[r]=-10000;
				}
			}
		depob(k,2);
		if ((fs[k].x==game.xm)&&(fs[k].y==game.ym))
			{
			fs[k].state=1;
			fs[k].wait=-1;
			if (game.clk==0) fs[k].wait=k*20;
			}
		}
	  }
	}

void depfr()
	{
		int	i,dx,dy,x,y,r,k,d[4];
	
	if (game.clkfruit)
		{
		if(--game.clkfruit==0)
			{
			createsprite(myform[24+(game.tableau&1)]
					,myfond[24+(game.tableau&1)]
					,game.xm,game.ym,24,24,5);
			fs[5].wait=15;
			fs[5].dir=rand()&3;
			fs[5].state=3;
			}
		}
		else
		{
		if (game.compte&1)
		  {
		  x=fs[5].x; y=fs[5].y;
		  if ( ((x&31)==8)&&((y&31)==8)&&((x!=game.xm)||(y!=game.ym)) )
			{
			while(((k=rand()&3)==((fs[5].dir+2)&3))
				||(possible(x>>5,y>>5,k)==0));
			if (fs[5].wait)
				{
				fs[5].wait--;
				fs[5].dir=k;
				}
				else
				{
				dx=game.xm; dy=game.ym;
				d[0]=dx-x; d[1]=dy-y; d[2]=x-dx; d[3]=y-dy;
				d[(2+fs[5].dir)&3]=-10000;
				fs[5].dir=-1;
				while(fs[5].dir==-1)
					{
					r=0;
					for(i=1;i<4;i++) if (d[i]>d[r]) r=i;
					if ( (possible(x>>5,y>>5,r))
					  || ( (x+32*((r==0)-(r==2))==game.xm)
					  &&(y+32*((r==1)-(r==3))==game.ym) ) )
						fs[5].dir=r;
						else d[r]=-10000;
					}
				}
			}
		  depob(5,1);
		  x=fs[5].x; y=fs[5].y;
		  if ((x==game.xm)&&(y==game.ym))
			{
			fs[5].type=0x8000;
			game.clkfruit=600;
			}
		  }
		}
	}

void timer()
	{
		int	i;

	game.compte+=1;
	game.compte&=3;
	if ((game.clk)&&(--game.clk==0))
		for(i=1;i<5;i++)
			if (fs[i].wait<0) fs[i].wait=i*20;
	}

void test()
	{
		int	i,x,y,fx,fy,k,b=6;
	
	x=fs[0].x; y=fs[0].y;
	if (game.clkfruit) b=5;
	for (i=1;i<b;i++)
		{
		k=fs[i].state;
		if((k==1)||(k==3))
			{
			fx=fs[i].x; fy=fs[i].y;
			fx-=x; fy-=y;
			if ((fx<16)&&(fx>-16)&&(fy<16)&&(fy>-16))
				{
				if (k==3)
				  {
				  addscore("00010000");
				  fs[i].type=0x8000;
				  game.clkfruit=600;
				  }
				else
				  {
				  if (game.clk)
					{
					if (game.clk>200)
						addscore("00005000");
						else
						addscore("00010000");

					fs[i].state=2;
					}
					else statefin=-2;
				  }
				}
			}
		}
	}


void pacman()
	{
		int	i,k;
		
	switch(operation)
	{
	case 0:
		game.tableau=0;
		game.tour=1;
		for (i=0;i<8;i++) game.score[i]=48;
		game.score[8]=0;
		game.vies=5;

		operation=1;
		break;

	case 1:
		initfond();
		affvies();
		affscore();
		game.eus=223;
		ct2=0;
		operation=2;
		break;

	case 2:
		for(i=ct2;i<616;i+=32)
			XCopyArea(display,fond,dessin,gc,i,0,1,400,i,0);
		ct2++;
		affscreen();
		if (ct2==32)
			{
			createsprite(myform[0],myfond[0]
				,game.xp,game.yp,24,24,0);
			spritemod=1;
			fs[0].dir=-1;
			fs[0].state=0;
			fs[0].wait=0;
			for(i=1;i<5;i++)
			{
			createsprite(myform[11+i],myfond[11+i]
				,game.xm,game.ym,24,24,i);
			fs[i].dir=i-1;
			fs[i].state=1;
			fs[i].wait=i*20;
			}
			fs[5].type=0x8000;
			fs[5].state=3;
			game.compte=0;
			game.clk=0;
			game.clkfruit=300;
			operation=3;
			lastkey=0;
			}

	case 3:
		rand();
		if ((i=getdirkey())!=-1000)
			{
			game.veut=i;
			operation=4;
			}
		break;

	case 4:
		statefin=0;
		depp();
		depf();
		depfr();
		test();
		timer();

		if (statefin<0) {
				operation=5;
				spritemod=2;
				ct2=0;
				}
		break;
	case 5:
		XSetForeground(display,gc,black);
		for(i=ct2;i<1040;i+=32)
			XDrawLine(display,dessin,gc,i,0,i-400,400);
		XSetForeground(display,gc,white);
		ct2++;
		affscreen();
		if (ct2==32)
			{
			for(i=0;i<6;i++) deletesprite(i);
			lastkey=0;
			operation=6;
			if (statefin==-2)
				if (--game.vies>=0)
					{
					affvies();
					operation=2;
					ct2=0;
					}
			if (statefin==-3)
				{
				addscore("00020000");
				if(++game.tableau==nbtableau)
					{
					game.tableau=0;
					if (game.tour<5) game.tour+=2;
					}
				operation=1;
				}
			}
		break;

	case 6:
		aftitre();
		operation=7;
		break;

	case 7:
		if (lastkey==32) operation=0;
		break;		

	default:
		break;


	}
	}






